#ifndef INPUT_H
#define INPUT_H

#include "../Daodan.h"

typedef uint32_t CustomActionCallbackArgument;

typedef void (*CustomActionCallback_t) (CustomActionCallbackArgument argument);

typedef enum {
	EVENT_KEYPRESS,
	EVENT_KEYDOWN,
} ActionEventType_t;

void Input_PatchCode ();

void Input_RegisterCustomAction (const char* actionname, ActionEventType_t eventType, uint32_t keydownTimeoutTicks, CustomActionCallback_t callback, CustomActionCallbackArgument callbackArgument);

extern bool DDgUseDaodanInput;
UUtBool ONICALL DDiPlatform_InputEvent_GetEvent(void);
bool DDrInput_WindowProc(HWND window, UINT msg, WPARAM wparam, LPARAM lparam,
                         LRESULT* res);
void ONICALL DDrActionBuffer_Get(short* count, LItActionBuffer** buffers);
void ONICALL DDrPlatform_InputEvent_GetMouse(int active, LItInputEvent *info);
void ONICALL DDrPlatform_Mode_Set(int active);
UUtBool ONICALL DDrPlatform_TestKey(int ch, int active);

#endif
